---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for Converter board registers
---------------------------------------------------------------------------------------
-- File           : C:\Users\debouhir\work\CONV-TTL-BLO\conv-ttl-blo\conv-ttl-blo-gw\ip_cores\conv-common-gw\modules\conv_regs_pkg.vhd
-- Author         : auto-generated by wbgen2 from C:\Users\debouhir\work\CONV-TTL-BLO\conv-ttl-blo\conv-ttl-blo-gw\ip_cores\conv-common-gw\modules\conv_regs.wb
-- Created        : 12/16/16 14:31:04
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE C:\Users\debouhir\work\CONV-TTL-BLO\conv-ttl-blo\conv-ttl-blo-gw\ip_cores\conv-common-gw\modules\conv_regs.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

package reg_wbgen2_pkg is
  
  
  -- Input registers (user design -> WB slave)
  
  type t_reg_in_registers is record
    bidr_i                                   : std_logic_vector(31 downto 0);
    sr_gwvers_i                              : std_logic_vector(7 downto 0);
    sr_switches_i                            : std_logic_vector(7 downto 0);
    sr_rtm_i                                 : std_logic_vector(5 downto 0);
    sr_i2c_wdto_i                            : std_logic;
    sr_wrpres_i                              : std_logic;
    sr_i2c_err_i                             : std_logic;
    sr_pmisse_i                              : std_logic_vector(5 downto 0);
    cr_rst_unlock_i                          : std_logic;
    cr_rst_i                                 : std_logic;
    ch1ttlpcr_i                              : std_logic_vector(31 downto 0);
    ch2ttlpcr_i                              : std_logic_vector(31 downto 0);
    ch3ttlpcr_i                              : std_logic_vector(31 downto 0);
    ch4ttlpcr_i                              : std_logic_vector(31 downto 0);
    ch5ttlpcr_i                              : std_logic_vector(31 downto 0);
    ch6ttlpcr_i                              : std_logic_vector(31 downto 0);
    ch1blopcr_i                              : std_logic_vector(31 downto 0);
    ch2blopcr_i                              : std_logic_vector(31 downto 0);
    ch3blopcr_i                              : std_logic_vector(31 downto 0);
    ch4blopcr_i                              : std_logic_vector(31 downto 0);
    ch5blopcr_i                              : std_logic_vector(31 downto 0);
    ch6blopcr_i                              : std_logic_vector(31 downto 0);
    tvlr_i                                   : std_logic_vector(31 downto 0);
    tvhr_i                                   : std_logic_vector(7 downto 0);
    tbmr_chan_i                              : std_logic_vector(5 downto 0);
    tbmr_wrtag_i                             : std_logic;
    tbcyr_i                                  : std_logic_vector(27 downto 0);
    tbtlr_i                                  : std_logic_vector(31 downto 0);
    tbthr_i                                  : std_logic_vector(7 downto 0);
    tbcsr_usedw_i                            : std_logic_vector(6 downto 0);
    tbcsr_full_i                             : std_logic;
    tbcsr_empty_i                            : std_logic;
    tbcsr_clr_i                              : std_logic;
    ch1ltscyr_i                              : std_logic_vector(27 downto 0);
    ch1ltstlr_i                              : std_logic_vector(31 downto 0);
    ch1ltsthr_tai_i                          : std_logic_vector(7 downto 0);
    ch1ltsthr_wrtag_i                        : std_logic;
    ch2ltscyr_i                              : std_logic_vector(27 downto 0);
    ch2ltstlr_i                              : std_logic_vector(31 downto 0);
    ch2ltsthr_tai_i                          : std_logic_vector(7 downto 0);
    ch2ltsthr_wrtag_i                        : std_logic;
    ch3ltscyr_i                              : std_logic_vector(27 downto 0);
    ch3ltstlr_i                              : std_logic_vector(31 downto 0);
    ch3ltsthr_tai_i                          : std_logic_vector(7 downto 0);
    ch3ltsthr_wrtag_i                        : std_logic;
    ch4ltscyr_i                              : std_logic_vector(27 downto 0);
    ch4ltstlr_i                              : std_logic_vector(31 downto 0);
    ch4ltsthr_tai_i                          : std_logic_vector(7 downto 0);
    ch4ltsthr_wrtag_i                        : std_logic;
    ch5ltscyr_i                              : std_logic_vector(27 downto 0);
    ch5ltstlr_i                              : std_logic_vector(31 downto 0);
    ch5ltsthr_tai_i                          : std_logic_vector(7 downto 0);
    ch5ltsthr_wrtag_i                        : std_logic;
    ch6ltscyr_i                              : std_logic_vector(27 downto 0);
    ch6ltstlr_i                              : std_logic_vector(31 downto 0);
    ch6ltsthr_tai_i                          : std_logic_vector(7 downto 0);
    ch6ltsthr_wrtag_i                        : std_logic;
    lsr_front_i                              : std_logic_vector(5 downto 0);
    lsr_frontinv_i                           : std_logic_vector(3 downto 0);
    lsr_rear_i                               : std_logic_vector(5 downto 0);
    lsr_frontfs_i                            : std_logic_vector(5 downto 0);
    lsr_frontinvfs_i                         : std_logic_vector(3 downto 0);
    lsr_rearfs_i                             : std_logic_vector(5 downto 0);
    mswr_switches_i                          : std_logic_vector(31 downto 0);
    ds18b20u_id_lsb_i                        : std_logic_vector(31 downto 0);
    ds18b20u_id_msb_i                        : std_logic_vector(31 downto 0);
    ds18b20u_temp_i                          : std_logic_vector(15 downto 0);
    end record;
  
  constant c_reg_in_registers_init_value: t_reg_in_registers := (
    bidr_i => (others => '0'),
    sr_gwvers_i => (others => '0'),
    sr_switches_i => (others => '0'),
    sr_rtm_i => (others => '0'),
    sr_i2c_wdto_i => '0',
    sr_wrpres_i => '0',
    sr_i2c_err_i => '0',
    sr_pmisse_i => (others => '0'),
    cr_rst_unlock_i => '0',
    cr_rst_i => '0',
    ch1ttlpcr_i => (others => '0'),
    ch2ttlpcr_i => (others => '0'),
    ch3ttlpcr_i => (others => '0'),
    ch4ttlpcr_i => (others => '0'),
    ch5ttlpcr_i => (others => '0'),
    ch6ttlpcr_i => (others => '0'),
    ch1blopcr_i => (others => '0'),
    ch2blopcr_i => (others => '0'),
    ch3blopcr_i => (others => '0'),
    ch4blopcr_i => (others => '0'),
    ch5blopcr_i => (others => '0'),
    ch6blopcr_i => (others => '0'),
    tvlr_i => (others => '0'),
    tvhr_i => (others => '0'),
    tbmr_chan_i => (others => '0'),
    tbmr_wrtag_i => '0',
    tbcyr_i => (others => '0'),
    tbtlr_i => (others => '0'),
    tbthr_i => (others => '0'),
    tbcsr_usedw_i => (others => '0'),
    tbcsr_full_i => '0',
    tbcsr_empty_i => '0',
    tbcsr_clr_i => '0',
    ch1ltscyr_i => (others => '0'),
    ch1ltstlr_i => (others => '0'),
    ch1ltsthr_tai_i => (others => '0'),
    ch1ltsthr_wrtag_i => '0',
    ch2ltscyr_i => (others => '0'),
    ch2ltstlr_i => (others => '0'),
    ch2ltsthr_tai_i => (others => '0'),
    ch2ltsthr_wrtag_i => '0',
    ch3ltscyr_i => (others => '0'),
    ch3ltstlr_i => (others => '0'),
    ch3ltsthr_tai_i => (others => '0'),
    ch3ltsthr_wrtag_i => '0',
    ch4ltscyr_i => (others => '0'),
    ch4ltstlr_i => (others => '0'),
    ch4ltsthr_tai_i => (others => '0'),
    ch4ltsthr_wrtag_i => '0',
    ch5ltscyr_i => (others => '0'),
    ch5ltstlr_i => (others => '0'),
    ch5ltsthr_tai_i => (others => '0'),
    ch5ltsthr_wrtag_i => '0',
    ch6ltscyr_i => (others => '0'),
    ch6ltstlr_i => (others => '0'),
    ch6ltsthr_tai_i => (others => '0'),
    ch6ltsthr_wrtag_i => '0',
    lsr_front_i => (others => '0'),
    lsr_frontinv_i => (others => '0'),
    lsr_rear_i => (others => '0'),
    lsr_frontfs_i => (others => '0'),
    lsr_frontinvfs_i => (others => '0'),
    lsr_rearfs_i => (others => '0'),
    mswr_switches_i => (others => '0'),
    ds18b20u_id_lsb_i => (others => '0'),
    ds18b20u_id_msb_i => (others => '0'),
    ds18b20u_temp_i => (others => '0')
    );
    
    -- Output registers (WB slave -> user design)
    
    type t_reg_out_registers is record
      sr_i2c_wdto_o                            : std_logic;
      sr_i2c_wdto_load_o                       : std_logic;
      sr_i2c_err_o                             : std_logic;
      sr_i2c_err_load_o                        : std_logic;
      sr_pmisse_o                              : std_logic_vector(5 downto 0);
      sr_pmisse_load_o                         : std_logic;
      cr_rst_unlock_o                          : std_logic;
      cr_rst_unlock_load_o                     : std_logic;
      cr_rst_o                                 : std_logic;
      cr_rst_load_o                            : std_logic;
      cr_mpt_o                                 : std_logic_vector(7 downto 0);
      cr_mpt_wr_o                              : std_logic;
      ch1ttlpcr_o                              : std_logic_vector(31 downto 0);
      ch1ttlpcr_load_o                         : std_logic;
      ch2ttlpcr_o                              : std_logic_vector(31 downto 0);
      ch2ttlpcr_load_o                         : std_logic;
      ch3ttlpcr_o                              : std_logic_vector(31 downto 0);
      ch3ttlpcr_load_o                         : std_logic;
      ch4ttlpcr_o                              : std_logic_vector(31 downto 0);
      ch4ttlpcr_load_o                         : std_logic;
      ch5ttlpcr_o                              : std_logic_vector(31 downto 0);
      ch5ttlpcr_load_o                         : std_logic;
      ch6ttlpcr_o                              : std_logic_vector(31 downto 0);
      ch6ttlpcr_load_o                         : std_logic;
      ch1blopcr_o                              : std_logic_vector(31 downto 0);
      ch1blopcr_load_o                         : std_logic;
      ch2blopcr_o                              : std_logic_vector(31 downto 0);
      ch2blopcr_load_o                         : std_logic;
      ch3blopcr_o                              : std_logic_vector(31 downto 0);
      ch3blopcr_load_o                         : std_logic;
      ch4blopcr_o                              : std_logic_vector(31 downto 0);
      ch4blopcr_load_o                         : std_logic;
      ch5blopcr_o                              : std_logic_vector(31 downto 0);
      ch5blopcr_load_o                         : std_logic;
      ch6blopcr_o                              : std_logic_vector(31 downto 0);
      ch6blopcr_load_o                         : std_logic;
      tvlr_o                                   : std_logic_vector(31 downto 0);
      tvlr_load_o                              : std_logic;
      tvhr_o                                   : std_logic_vector(7 downto 0);
      tvhr_load_o                              : std_logic;
      tbcsr_clr_o                              : std_logic;
      tbcsr_clr_load_o                         : std_logic;
      end record;
    
    constant c_reg_out_registers_init_value: t_reg_out_registers := (
      sr_i2c_wdto_o => '0',
      sr_i2c_wdto_load_o => '0',
      sr_i2c_err_o => '0',
      sr_i2c_err_load_o => '0',
      sr_pmisse_o => (others => '0'),
      sr_pmisse_load_o => '0',
      cr_rst_unlock_o => '0',
      cr_rst_unlock_load_o => '0',
      cr_rst_o => '0',
      cr_rst_load_o => '0',
      cr_mpt_o => (others => '0'),
      cr_mpt_wr_o => '0',
      ch1ttlpcr_o => (others => '0'),
      ch1ttlpcr_load_o => '0',
      ch2ttlpcr_o => (others => '0'),
      ch2ttlpcr_load_o => '0',
      ch3ttlpcr_o => (others => '0'),
      ch3ttlpcr_load_o => '0',
      ch4ttlpcr_o => (others => '0'),
      ch4ttlpcr_load_o => '0',
      ch5ttlpcr_o => (others => '0'),
      ch5ttlpcr_load_o => '0',
      ch6ttlpcr_o => (others => '0'),
      ch6ttlpcr_load_o => '0',
      ch1blopcr_o => (others => '0'),
      ch1blopcr_load_o => '0',
      ch2blopcr_o => (others => '0'),
      ch2blopcr_load_o => '0',
      ch3blopcr_o => (others => '0'),
      ch3blopcr_load_o => '0',
      ch4blopcr_o => (others => '0'),
      ch4blopcr_load_o => '0',
      ch5blopcr_o => (others => '0'),
      ch5blopcr_load_o => '0',
      ch6blopcr_o => (others => '0'),
      ch6blopcr_load_o => '0',
      tvlr_o => (others => '0'),
      tvlr_load_o => '0',
      tvhr_o => (others => '0'),
      tvhr_load_o => '0',
      tbcsr_clr_o => '0',
      tbcsr_clr_load_o => '0'
      );
    function "or" (left, right: t_reg_in_registers) return t_reg_in_registers;
    function f_x_to_zero (x:std_logic) return std_logic;
    function f_x_to_zero (x:std_logic_vector) return std_logic_vector;
end package;

package body reg_wbgen2_pkg is
function f_x_to_zero (x:std_logic) return std_logic is
begin
if x = '1' then
return '1';
else
return '0';
end if;
end function;
function f_x_to_zero (x:std_logic_vector) return std_logic_vector is
variable tmp: std_logic_vector(x'length-1 downto 0);
begin
for i in 0 to x'length-1 loop
if(x(i) = 'X' or x(i) = 'U') then
tmp(i):= '0';
else
tmp(i):=x(i);
end if; 
end loop; 
return tmp;
end function;
function "or" (left, right: t_reg_in_registers) return t_reg_in_registers is
variable tmp: t_reg_in_registers;
begin
tmp.bidr_i := f_x_to_zero(left.bidr_i) or f_x_to_zero(right.bidr_i);
tmp.sr_gwvers_i := f_x_to_zero(left.sr_gwvers_i) or f_x_to_zero(right.sr_gwvers_i);
tmp.sr_switches_i := f_x_to_zero(left.sr_switches_i) or f_x_to_zero(right.sr_switches_i);
tmp.sr_rtm_i := f_x_to_zero(left.sr_rtm_i) or f_x_to_zero(right.sr_rtm_i);
tmp.sr_i2c_wdto_i := f_x_to_zero(left.sr_i2c_wdto_i) or f_x_to_zero(right.sr_i2c_wdto_i);
tmp.sr_wrpres_i := f_x_to_zero(left.sr_wrpres_i) or f_x_to_zero(right.sr_wrpres_i);
tmp.sr_i2c_err_i := f_x_to_zero(left.sr_i2c_err_i) or f_x_to_zero(right.sr_i2c_err_i);
tmp.sr_pmisse_i := f_x_to_zero(left.sr_pmisse_i) or f_x_to_zero(right.sr_pmisse_i);
tmp.cr_rst_unlock_i := f_x_to_zero(left.cr_rst_unlock_i) or f_x_to_zero(right.cr_rst_unlock_i);
tmp.cr_rst_i := f_x_to_zero(left.cr_rst_i) or f_x_to_zero(right.cr_rst_i);
tmp.ch1ttlpcr_i := f_x_to_zero(left.ch1ttlpcr_i) or f_x_to_zero(right.ch1ttlpcr_i);
tmp.ch2ttlpcr_i := f_x_to_zero(left.ch2ttlpcr_i) or f_x_to_zero(right.ch2ttlpcr_i);
tmp.ch3ttlpcr_i := f_x_to_zero(left.ch3ttlpcr_i) or f_x_to_zero(right.ch3ttlpcr_i);
tmp.ch4ttlpcr_i := f_x_to_zero(left.ch4ttlpcr_i) or f_x_to_zero(right.ch4ttlpcr_i);
tmp.ch5ttlpcr_i := f_x_to_zero(left.ch5ttlpcr_i) or f_x_to_zero(right.ch5ttlpcr_i);
tmp.ch6ttlpcr_i := f_x_to_zero(left.ch6ttlpcr_i) or f_x_to_zero(right.ch6ttlpcr_i);
tmp.ch1blopcr_i := f_x_to_zero(left.ch1blopcr_i) or f_x_to_zero(right.ch1blopcr_i);
tmp.ch2blopcr_i := f_x_to_zero(left.ch2blopcr_i) or f_x_to_zero(right.ch2blopcr_i);
tmp.ch3blopcr_i := f_x_to_zero(left.ch3blopcr_i) or f_x_to_zero(right.ch3blopcr_i);
tmp.ch4blopcr_i := f_x_to_zero(left.ch4blopcr_i) or f_x_to_zero(right.ch4blopcr_i);
tmp.ch5blopcr_i := f_x_to_zero(left.ch5blopcr_i) or f_x_to_zero(right.ch5blopcr_i);
tmp.ch6blopcr_i := f_x_to_zero(left.ch6blopcr_i) or f_x_to_zero(right.ch6blopcr_i);
tmp.tvlr_i := f_x_to_zero(left.tvlr_i) or f_x_to_zero(right.tvlr_i);
tmp.tvhr_i := f_x_to_zero(left.tvhr_i) or f_x_to_zero(right.tvhr_i);
tmp.tbmr_chan_i := f_x_to_zero(left.tbmr_chan_i) or f_x_to_zero(right.tbmr_chan_i);
tmp.tbmr_wrtag_i := f_x_to_zero(left.tbmr_wrtag_i) or f_x_to_zero(right.tbmr_wrtag_i);
tmp.tbcyr_i := f_x_to_zero(left.tbcyr_i) or f_x_to_zero(right.tbcyr_i);
tmp.tbtlr_i := f_x_to_zero(left.tbtlr_i) or f_x_to_zero(right.tbtlr_i);
tmp.tbthr_i := f_x_to_zero(left.tbthr_i) or f_x_to_zero(right.tbthr_i);
tmp.tbcsr_usedw_i := f_x_to_zero(left.tbcsr_usedw_i) or f_x_to_zero(right.tbcsr_usedw_i);
tmp.tbcsr_full_i := f_x_to_zero(left.tbcsr_full_i) or f_x_to_zero(right.tbcsr_full_i);
tmp.tbcsr_empty_i := f_x_to_zero(left.tbcsr_empty_i) or f_x_to_zero(right.tbcsr_empty_i);
tmp.tbcsr_clr_i := f_x_to_zero(left.tbcsr_clr_i) or f_x_to_zero(right.tbcsr_clr_i);
tmp.ch1ltscyr_i := f_x_to_zero(left.ch1ltscyr_i) or f_x_to_zero(right.ch1ltscyr_i);
tmp.ch1ltstlr_i := f_x_to_zero(left.ch1ltstlr_i) or f_x_to_zero(right.ch1ltstlr_i);
tmp.ch1ltsthr_tai_i := f_x_to_zero(left.ch1ltsthr_tai_i) or f_x_to_zero(right.ch1ltsthr_tai_i);
tmp.ch1ltsthr_wrtag_i := f_x_to_zero(left.ch1ltsthr_wrtag_i) or f_x_to_zero(right.ch1ltsthr_wrtag_i);
tmp.ch2ltscyr_i := f_x_to_zero(left.ch2ltscyr_i) or f_x_to_zero(right.ch2ltscyr_i);
tmp.ch2ltstlr_i := f_x_to_zero(left.ch2ltstlr_i) or f_x_to_zero(right.ch2ltstlr_i);
tmp.ch2ltsthr_tai_i := f_x_to_zero(left.ch2ltsthr_tai_i) or f_x_to_zero(right.ch2ltsthr_tai_i);
tmp.ch2ltsthr_wrtag_i := f_x_to_zero(left.ch2ltsthr_wrtag_i) or f_x_to_zero(right.ch2ltsthr_wrtag_i);
tmp.ch3ltscyr_i := f_x_to_zero(left.ch3ltscyr_i) or f_x_to_zero(right.ch3ltscyr_i);
tmp.ch3ltstlr_i := f_x_to_zero(left.ch3ltstlr_i) or f_x_to_zero(right.ch3ltstlr_i);
tmp.ch3ltsthr_tai_i := f_x_to_zero(left.ch3ltsthr_tai_i) or f_x_to_zero(right.ch3ltsthr_tai_i);
tmp.ch3ltsthr_wrtag_i := f_x_to_zero(left.ch3ltsthr_wrtag_i) or f_x_to_zero(right.ch3ltsthr_wrtag_i);
tmp.ch4ltscyr_i := f_x_to_zero(left.ch4ltscyr_i) or f_x_to_zero(right.ch4ltscyr_i);
tmp.ch4ltstlr_i := f_x_to_zero(left.ch4ltstlr_i) or f_x_to_zero(right.ch4ltstlr_i);
tmp.ch4ltsthr_tai_i := f_x_to_zero(left.ch4ltsthr_tai_i) or f_x_to_zero(right.ch4ltsthr_tai_i);
tmp.ch4ltsthr_wrtag_i := f_x_to_zero(left.ch4ltsthr_wrtag_i) or f_x_to_zero(right.ch4ltsthr_wrtag_i);
tmp.ch5ltscyr_i := f_x_to_zero(left.ch5ltscyr_i) or f_x_to_zero(right.ch5ltscyr_i);
tmp.ch5ltstlr_i := f_x_to_zero(left.ch5ltstlr_i) or f_x_to_zero(right.ch5ltstlr_i);
tmp.ch5ltsthr_tai_i := f_x_to_zero(left.ch5ltsthr_tai_i) or f_x_to_zero(right.ch5ltsthr_tai_i);
tmp.ch5ltsthr_wrtag_i := f_x_to_zero(left.ch5ltsthr_wrtag_i) or f_x_to_zero(right.ch5ltsthr_wrtag_i);
tmp.ch6ltscyr_i := f_x_to_zero(left.ch6ltscyr_i) or f_x_to_zero(right.ch6ltscyr_i);
tmp.ch6ltstlr_i := f_x_to_zero(left.ch6ltstlr_i) or f_x_to_zero(right.ch6ltstlr_i);
tmp.ch6ltsthr_tai_i := f_x_to_zero(left.ch6ltsthr_tai_i) or f_x_to_zero(right.ch6ltsthr_tai_i);
tmp.ch6ltsthr_wrtag_i := f_x_to_zero(left.ch6ltsthr_wrtag_i) or f_x_to_zero(right.ch6ltsthr_wrtag_i);
tmp.lsr_front_i := f_x_to_zero(left.lsr_front_i) or f_x_to_zero(right.lsr_front_i);
tmp.lsr_frontinv_i := f_x_to_zero(left.lsr_frontinv_i) or f_x_to_zero(right.lsr_frontinv_i);
tmp.lsr_rear_i := f_x_to_zero(left.lsr_rear_i) or f_x_to_zero(right.lsr_rear_i);
tmp.lsr_frontfs_i := f_x_to_zero(left.lsr_frontfs_i) or f_x_to_zero(right.lsr_frontfs_i);
tmp.lsr_frontinvfs_i := f_x_to_zero(left.lsr_frontinvfs_i) or f_x_to_zero(right.lsr_frontinvfs_i);
tmp.lsr_rearfs_i := f_x_to_zero(left.lsr_rearfs_i) or f_x_to_zero(right.lsr_rearfs_i);
tmp.mswr_switches_i := f_x_to_zero(left.mswr_switches_i) or f_x_to_zero(right.mswr_switches_i);
tmp.ds18b20u_id_lsb_i := f_x_to_zero(left.ds18b20u_id_lsb_i) or f_x_to_zero(right.ds18b20u_id_lsb_i);
tmp.ds18b20u_id_msb_i := f_x_to_zero(left.ds18b20u_id_msb_i) or f_x_to_zero(right.ds18b20u_id_msb_i);
tmp.ds18b20u_temp_i := f_x_to_zero(left.ds18b20u_temp_i) or f_x_to_zero(right.ds18b20u_temp_i);
return tmp;
end function;
end package body;
